=== 3rdparty/catch2/CMakeLists.txt ===
project(${CATCH2_LIBRARY})

set(CATCH2_MAJOR_VERSION 2 PARENT_SCOPE)
set(CATCH2_MINOR_VERSION 9 PARENT_SCOPE)
set(CATCH2_PATCH_VERSION 2 PARENT_SCOPE)
