=== 3rdparty/stb_image/CMakeLists.txt ===
project(${STBIMAGE_LIBRARY})

set(STBIMAGE_MAJOR_VERSION 2  PARENT_SCOPE)
set(STBIMAGE_MINOR_VERSION 22 PARENT_SCOPE)
set(STBIMAGE_PATCH_VERSION 0  PARENT_SCOPE)
