=== debian/changelog ===
visp (3.3.0-5) unstable; urgency=medium

  * Introduce new patch to move away from libdc1394-22-dev to
    libdc1394-dev (Closes: #970840)

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Mon, 02 Nov 2020 11:46:09 +0100

visp (3.3.0-4) unstable; urgency=medium

  * Add patch to remove boost detection (Closes: #962449)
    - remove boost detection in modules/ar/CMakeLists.txt
    - update cmake tools to generate visp.pc

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Fri, 12 Jun 2020 12:13:23 +0200

visp (3.3.0-3) unstable; urgency=medium

  * Source only upload for debian build 

 -- Olivier Sallou <osallou@debian.org>  Mon, 20 Apr 2020 06:39:29 +0000

visp (3.3.0-2) unstable; urgency=medium

  [ Fabien Spindler ]
  * Add patch to fix build and test on s390x big endian arch
  * Update control file to install missing dev packages (Closes: #945384)
  * Add patch to fix spelling errors detected by lintian

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Fri, 28 Feb 2020 08:40:50 +0100

visp (3.3.0-1) unstable; urgency=medium

  * Remove 3.2.0 patches
  * New upstream version 3.3.0
  * Update debian material for visp 3.3.0 (Closes: #922600) (Closes: #945384)
  * Add patches for visp 3.3.0
  * Update copyright file
  * lintian overrides source-contains-prebuilt-java-object
  * lintian overrides rules-requires-root-missing
  * Fix multiarch hinter issue on libvisp-dev

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Mon, 17 Feb 2020 10:04:07 +0100

visp (3.2.0-2) unstable; urgency=medium

  * Mute lintian warning privacy-breach-generic
  * Remove useless SoQt 3rd party usage (Closes: #944548)
  * Upgrade debhelper compat version as suggested by lintian

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Thu, 28 Nov 2019 12:37:06 +0100

visp (3.2.0-1) unstable; urgency=medium

  * Remove 3.1.0 patches
  * New upstream version 3.2.0
  * Remove deprecated files used to package visp 3.0.0
  * Rename packages to match release version
  * Update debian material for visp 3.2.0
  * Add patches for visp 3.2.0
  * Set CMAKE_INSTALL_LIBDIR
  * Fix lintian warnings
  * Remove dbg packages to satisfy lintian
    debian-control-has-obsolete-dbg-package
  * Fix out of date standards version
  * Remove trailing whitespaces
  * Fix dh_shlibs issue introcucing a new patch
  * Add patch to consider empty logname
  * Fix lintian doc-base-file-references-missing-file
  * Rename package files

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Fri, 25 Jan 2019 16:22:41 +0100
